<?php
// +----------------------------------------------------------------------
// | 管理员查询
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\admin\controller\Auth;

use app\common\controller\_Admin;
use app\admin\model\AuthRole as Role;
use app\admin\model\AuthAdmin as Admin;

class admin_list extends _Admin
{
   
    // 默认留空即可
    protected function initialize()
    {
        parent::initialize();
    }

    // 统一返回方法
    // $param 必留，用于接收get、post的参数传递
    public function run($param=[], $_this) {
        if (\think\facade\Request::isAjax()) {
            return $this->showlist($param);
        }
        return $this->fetch('auth/admin/list');
    }

    // 列表
    private function showlist($param=[]) {
        $where = $this->_where($param);
        $list = Admin::alias('A')->join('auth_role B', 'A.role = B.id', 'LEFT')->where($where)->order('id DESC')->field('A.*, B.name as role_name')->page($param['page'])->limit($param['limit'])->select();
        $count = Admin::alias('A')->where($where)->count();
        foreach ($list as $k=>$v) {
            switch ($v['type']) {
                case 1: $list[$k]['type'] = '管理员'; break;
                case 2: $list[$k]['type'] = '加盟商'; break;
                case 3: $list[$k]['type'] = '商户'; break;
            }
            $list[$k]['status'] = $v['status']==1?'开启':'关闭';
            if ($v['role'] == 0) {
                $v['role_name'] = '超级管理员';
            }
        }
        return self::_list('0', '', $count, $list);
    }

    // 搜索条件
    private function _where($param=[]) {
        $where = [];
        if (self::isset_empty($param, 'nick')) {
            $where[] =  ['A.nick','like', "%".$param['nick']."%"];
        }
        if (self::isset_empty($param, 'name')) {
            $where[] = ['A.name','like', "%".$param['name']."%"];
        }
        if (self::isset_empty($param, 'phone')) {
            $where[] = ['A.phone', 'like', "%".$param['phone']."%"];
        }
        if (self::isset_empty($param, 'status')) {
            $where['A.status'] = $param['status'];
        }
        if (self::isset_empty($param, 'type')) {
            $where['A.type'] = $param['type'];
        }
        return $where;
    }

}
