<?php
// +----------------------------------------------------------------------
// | 角色权限修改
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\admin\controller\Auth;

use app\common\controller\_Admin;
use app\admin\model\AuthMenu as Menu;
use app\admin\model\AuthAdminMenu as AdminMenu;

class admin_menu extends _Admin
{
   
    // 默认留空即可
    protected function initialize()
    {
        parent::initialize();
    }

    // 统一返回方法
    // $param 必留，用于接收get、post的参数传递
    public function run($param=[], $_this) {
        if (\think\facade\Request::isAjax()) {
            return $this->update($param);
        }

        $info = AdminMenu::where('admin', $param['pid'])->field('id, admin, menu_list')->find();
        if (!$info) {
            $info = [
                'id' => 0,
                'menu_list' => '',
                'admin' => $param['pid'],
            ];
        }
        $this->assign('info', $info);
        $this->assign('menu', json_encode($this->showlist($info['menu_list']), JSON_UNESCAPED_UNICODE));
        return $this->fetch('auth/admin/menu');
    }

    // 修改独立权限
    private function update($param=[]) {
        if ($param['id'] == 0) {
            unset($param['id']);
            $res = AdminMenu::create($param);
        } else {
            $res = AdminMenu::update($param);
        }

        if ($res != false) {
            return $this->_json('00', '修改成功！');
        }

        return $this->_json('01', '修改失败！');
    }

    // 列表
    private function showlist($menu) {
        $array = explode(',', $menu);
        $list = Menu::all(function ($query) {
            $query->order('path ASC')->where([
                'public' => 0,
                'status' => 1,
            ])->field('id as nid, pid as parentid, name');
        });

        foreach ($list as $k=>$v) {
            if (in_array($v['nid'], $array)) {
                $list[$k]['checked']= true;
            } else {
                $list[$k]['checked']= false;
            }
            
            $list[$k]['id'] = $v['nid'];
        }

        return $list;
    }


}
